package com.iformall.service;

import com.github.pagehelper.PageInfo;
import com.iformall.common.ResultData;
import com.iformall.domain.po.MallUserInfo;
import com.iformall.domain.po.WxBillProperty;
import com.iformall.domain.po.WxBillRent;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;

/**
 * @author gongbiao
 */
public interface WxBillPropertyService {


    /**
     * 根据实体查询分页列表
     *
     * @param offset
     * @param limit
     * @param record
     * @return
     */
    PageInfo<WxBillProperty> listAsPage(WxBillProperty record, Integer pageIndex, Integer pageSize);

    void updateBillStatus(WxBillProperty record);

    /**
     * 根据Id获得实体
     *
     * @param id
     * @return
     */
    WxBillProperty getById(Long id);

    /**
     * 保存或更新实体
     *
     * @param record
     * @param user
     */
    ResultData saveOrUpdate(WxBillProperty record, MallUserInfo user);

    /**
     * 修改滞纳金
     *
     * @param record
     * @param user
     */
    ResultData updateLatePayMoney(WxBillProperty record, MallUserInfo user);

    /**
     * 根据Id删除实体
     *
     * @param id
     */
    void deleteById(Long id);


    PageInfo<WxBillProperty> findByPropertyContractId(Long id, String tenantId, Integer pageIndex, Integer pageSize);

    ResultData updatePaid(Long id);

    Object detail(Long id);

    ResultData updateLatePayStatus(WxBillProperty wxBillProperty);

    void exportBill(HttpServletRequest request, HttpServletResponse response, WxBillProperty wxBillProperty);
}
